//
// Copyright (C) 2022 Open Source Robotics Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.28.1
// 	protoc        (unknown)
// source: domain/simulation.proto

package domain

import (
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	timestamppb "google.golang.org/protobuf/types/known/timestamppb"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

// Simulation contains information about a simulation run.
// There is a one-to-one relationship between a Simulation and a Scenario.
type Simulation struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// GroupId is the Simulation identifier. It's used across different services when they need to refer
	// to a specific Simulation.
	GroupId string `protobuf:"bytes,1,opt,name=group_id,json=groupId,proto3" json:"group_id,omitempty"`
	// LaunchedAt is the date and time at which this Simulation has been launched.
	// A nil value means that the simulation hasn't been launched yet, and is likely waiting in a queue to get picker up by a worker.
	LaunchedAt *timestamppb.Timestamp `protobuf:"bytes,2,opt,name=launched_at,json=launchedAt,proto3" json:"launched_at,omitempty"`
	// StoppedAt is the date and time at which this Simulation has stopped.
	StoppedAt *timestamppb.Timestamp `protobuf:"bytes,3,opt,name=stopped_at,json=stoppedAt,proto3" json:"stopped_at,omitempty"`
	// Name contains a user-defined name for this Simulation.
	Name string `protobuf:"bytes,4,opt,name=name,proto3" json:"name,omitempty"`
	// Image contains a URL to a valid OCI image that was used to run this simulation.
	Image string `protobuf:"bytes,5,opt,name=image,proto3" json:"image,omitempty"`
	// Status contains the current status of this Simulation.
	Status string `protobuf:"bytes,6,opt,name=status,proto3" json:"status,omitempty"`
	// Error contains an error message explaining why the simulation failed. If set to nil, the simulation doesn't have
	// any errors.
	Error string `protobuf:"bytes,7,opt,name=error,proto3" json:"error,omitempty"`
	// Restarted is set to true if the simulation has been restarted.
	Restarted bool `protobuf:"varint,8,opt,name=restarted,proto3" json:"restarted,omitempty"`
}

func (x *Simulation) Reset() {
	*x = Simulation{}
	if protoimpl.UnsafeEnabled {
		mi := &file_domain_simulation_proto_msgTypes[0]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *Simulation) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Simulation) ProtoMessage() {}

func (x *Simulation) ProtoReflect() protoreflect.Message {
	mi := &file_domain_simulation_proto_msgTypes[0]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Simulation.ProtoReflect.Descriptor instead.
func (*Simulation) Descriptor() ([]byte, []int) {
	return file_domain_simulation_proto_rawDescGZIP(), []int{0}
}

func (x *Simulation) GetGroupId() string {
	if x != nil {
		return x.GroupId
	}
	return ""
}

func (x *Simulation) GetLaunchedAt() *timestamppb.Timestamp {
	if x != nil {
		return x.LaunchedAt
	}
	return nil
}

func (x *Simulation) GetStoppedAt() *timestamppb.Timestamp {
	if x != nil {
		return x.StoppedAt
	}
	return nil
}

func (x *Simulation) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}

func (x *Simulation) GetImage() string {
	if x != nil {
		return x.Image
	}
	return ""
}

func (x *Simulation) GetStatus() string {
	if x != nil {
		return x.Status
	}
	return ""
}

func (x *Simulation) GetError() string {
	if x != nil {
		return x.Error
	}
	return ""
}

func (x *Simulation) GetRestarted() bool {
	if x != nil {
		return x.Restarted
	}
	return false
}

var File_domain_simulation_proto protoreflect.FileDescriptor

var file_domain_simulation_proto_rawDesc = []byte{
	0x0a, 0x17, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e, 0x2f, 0x73, 0x69, 0x6d, 0x75, 0x6c, 0x61, 0x74,
	0x69, 0x6f, 0x6e, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x06, 0x64, 0x6f, 0x6d, 0x61, 0x69,
	0x6e, 0x1a, 0x1f, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62,
	0x75, 0x66, 0x2f, 0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x2e, 0x70, 0x72, 0x6f,
	0x74, 0x6f, 0x1a, 0x15, 0x64, 0x6f, 0x6d, 0x61, 0x69, 0x6e, 0x2f, 0x61, 0x72, 0x74, 0x69, 0x66,
	0x61, 0x63, 0x74, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x22, 0x95, 0x02, 0x0a, 0x0a, 0x53, 0x69,
	0x6d, 0x75, 0x6c, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x19, 0x0a, 0x08, 0x67, 0x72, 0x6f, 0x75,
	0x70, 0x5f, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x07, 0x67, 0x72, 0x6f, 0x75,
	0x70, 0x49, 0x64, 0x12, 0x3b, 0x0a, 0x0b, 0x6c, 0x61, 0x75, 0x6e, 0x63, 0x68, 0x65, 0x64, 0x5f,
	0x61, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c,
	0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x54, 0x69, 0x6d, 0x65, 0x73,
	0x74, 0x61, 0x6d, 0x70, 0x52, 0x0a, 0x6c, 0x61, 0x75, 0x6e, 0x63, 0x68, 0x65, 0x64, 0x41, 0x74,
	0x12, 0x39, 0x0a, 0x0a, 0x73, 0x74, 0x6f, 0x70, 0x70, 0x65, 0x64, 0x5f, 0x61, 0x74, 0x18, 0x03,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72,
	0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70,
	0x52, 0x09, 0x73, 0x74, 0x6f, 0x70, 0x70, 0x65, 0x64, 0x41, 0x74, 0x12, 0x12, 0x0a, 0x04, 0x6e,
	0x61, 0x6d, 0x65, 0x18, 0x04, 0x20, 0x01, 0x28, 0x09, 0x52, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x12,
	0x14, 0x0a, 0x05, 0x69, 0x6d, 0x61, 0x67, 0x65, 0x18, 0x05, 0x20, 0x01, 0x28, 0x09, 0x52, 0x05,
	0x69, 0x6d, 0x61, 0x67, 0x65, 0x12, 0x16, 0x0a, 0x06, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x18,
	0x06, 0x20, 0x01, 0x28, 0x09, 0x52, 0x06, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x14, 0x0a,
	0x05, 0x65, 0x72, 0x72, 0x6f, 0x72, 0x18, 0x07, 0x20, 0x01, 0x28, 0x09, 0x52, 0x05, 0x65, 0x72,
	0x72, 0x6f, 0x72, 0x12, 0x1c, 0x0a, 0x09, 0x72, 0x65, 0x73, 0x74, 0x61, 0x72, 0x74, 0x65, 0x64,
	0x18, 0x08, 0x20, 0x01, 0x28, 0x08, 0x52, 0x09, 0x72, 0x65, 0x73, 0x74, 0x61, 0x72, 0x74, 0x65,
	0x64, 0x42, 0x31, 0x5a, 0x2f, 0x67, 0x69, 0x74, 0x6c, 0x61, 0x62, 0x2e, 0x63, 0x6f, 0x6d, 0x2f,
	0x69, 0x67, 0x6e, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x72, 0x6f, 0x62, 0x6f, 0x74, 0x69, 0x63, 0x73,
	0x2f, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x73, 0x69, 0x6d, 0x2f, 0x61, 0x70, 0x69, 0x2f, 0x64, 0x6f,
	0x6d, 0x61, 0x69, 0x6e, 0x62, 0x06, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_domain_simulation_proto_rawDescOnce sync.Once
	file_domain_simulation_proto_rawDescData = file_domain_simulation_proto_rawDesc
)

func file_domain_simulation_proto_rawDescGZIP() []byte {
	file_domain_simulation_proto_rawDescOnce.Do(func() {
		file_domain_simulation_proto_rawDescData = protoimpl.X.CompressGZIP(file_domain_simulation_proto_rawDescData)
	})
	return file_domain_simulation_proto_rawDescData
}

var file_domain_simulation_proto_msgTypes = make([]protoimpl.MessageInfo, 1)
var file_domain_simulation_proto_goTypes = []interface{}{
	(*Simulation)(nil),            // 0: domain.Simulation
	(*timestamppb.Timestamp)(nil), // 1: google.protobuf.Timestamp
}
var file_domain_simulation_proto_depIdxs = []int32{
	1, // 0: domain.Simulation.launched_at:type_name -> google.protobuf.Timestamp
	1, // 1: domain.Simulation.stopped_at:type_name -> google.protobuf.Timestamp
	2, // [2:2] is the sub-list for method output_type
	2, // [2:2] is the sub-list for method input_type
	2, // [2:2] is the sub-list for extension type_name
	2, // [2:2] is the sub-list for extension extendee
	0, // [0:2] is the sub-list for field type_name
}

func init() { file_domain_simulation_proto_init() }
func file_domain_simulation_proto_init() {
	if File_domain_simulation_proto != nil {
		return
	}
	file_domain_artifact_proto_init()
	if !protoimpl.UnsafeEnabled {
		file_domain_simulation_proto_msgTypes[0].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*Simulation); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_domain_simulation_proto_rawDesc,
			NumEnums:      0,
			NumMessages:   1,
			NumExtensions: 0,
			NumServices:   0,
		},
		GoTypes:           file_domain_simulation_proto_goTypes,
		DependencyIndexes: file_domain_simulation_proto_depIdxs,
		MessageInfos:      file_domain_simulation_proto_msgTypes,
	}.Build()
	File_domain_simulation_proto = out.File
	file_domain_simulation_proto_rawDesc = nil
	file_domain_simulation_proto_goTypes = nil
	file_domain_simulation_proto_depIdxs = nil
}
